{ lipuülesanne                                                              }
{ paigutada NxN malelauale N lippu nii, et nad üksteist ei tulista          }

{ loendab lahendused kõigi variantide läbivaatuse teel                      }

const maxn = 30;                    { maksimaalne laua suurus / lippude arv }

var nn : integer;                               { laua suurus / lippude arv }
var rr : array [1..maxn] of integer;                     { lippude asukohad }
var vr : array [1..maxn] of boolean;                           { vabad read }
var d1 : array [2..2*maxn] of boolean;                { vabad / diagonaalid }
var d2 : array [1-maxn..maxn-1] of boolean;           { vabad \ diagonaalid }
var ll, vv : longint;                          { lahenduste, variantide arv }

{ kontrollib, et väli [r,v] pole tule all }
function ok(r, v : integer) : boolean;
begin
   exit(vr[r] and d1[r + v] and d2[r - v]);
end;

{ paneb lipu kohale [r,v] }
procedure pane(r, v : integer);
begin
   rr[v] := r;
   vr[r] := false; d1[r + v] := false; d2[r - v] := false;
end;

{ eemaldab lipu kohalt [r,v] }
procedure vota(r, v : integer);
begin
   vr[r] := true; d1[r + v] := true; d2[r - v] := true;
end;

{ otsib kohta järgmisele lipule }
procedure otsi(n : integer);
var r : integer;
begin
   if n > nn then begin                         { kui kõik lipud paigutatud }
      { kui me siia jõuame, siis on see juba kindlalt lahendus }
      ll := ll + 1;                                    { loendame lahenduse }
   end else begin
      for r := 1 to nn do begin
         if ok(r, n) then begin                    { kui on osaline variant }
            vv := vv + 1;                               { loendame variandi }
            pane(r, n);                                   { uus lipp kohale }
            otsi(n + 1);                          { paigutame järgmise lipu }
            vota(r, n);                                   { uus lipp minema }
         end;
      end;
   end;
end;

var i : integer;
begin
   write('N = '); readln(nn);
   for i := 1 to nn do vr[i] := true;             { alguses kõik read vabad }
   for i := 2 to 2*nn do d1[i] := true;       { ja kõik / diagonaalid vabad }
   for i := 1-nn to nn-1 do d2[i] := true;    { ja kõik \ diagonaalid vabad }
   ll := 0; vv := 0;
   otsi(1);
   writeln('Vaadeldud ', vv, ' varianti, leitud ', ll, ' lahendust');
end.
